function [K,tau,y_pred] = mhe(inputs)

persistent first s a

if isempty(first)
    % initialization
    s = 'http://byu.apmonitor.com';
    a = ['mhe' int2str(rand()*10000)];
    msg = mhe_init(s,a)
end

y_meas = inputs(1);
u_meas = inputs(2);

apm_meas(s,a,'y',y_meas);
apm_meas(s,a,'u',u_meas);

apm(s,a,'solve');

z = apm_sol(s,a);

K = z.x.k(end);
tau = z.x.tau(end);
y_pred = z.x.y(end);

if isempty(first)
    apm_web(s,a);
    first = false;
end

return