function [outputs] = mpc(inputs)

persistent first s a

if isempty(first)
    % initialization
    s = 'http://byu.apmonitor.com';
    a = ['mpc' int2str(rand()*10000)];
    msg = mpc_init(s,a)
end

sp = inputs(1);
y_meas = inputs(2);
k_pred = inputs(3);
tau_pred = inputs(4);
y_pred = inputs(5);

apm_meas(s,a,'y',y_meas);
%apm_meas(s,a,'y',y_pred);
apm_meas(s,a,'k',k_pred);
apm_meas(s,a,'tau',tau_pred);

sphi = sp + 0.1;
splo = sp - 0.1;
apm_option(s,a,'y.sphi',sphi);
apm_option(s,a,'y.splo',splo);
apm_option(s,a,'y.sp',sp);

apm(s,a,'solve');

%z = apm_sol(s,a);

u = apm_tag(s,a,'u.newval');

outputs(1) = u;

if isempty(first)
    apm_web(s,a);
    first = false;
end

return